package paas_golang

import (
	"fmt"
	"paas-golang/busi"
	"paas-golang/macros"
	"testing"
	"time"
)

const (
	AK        = "G001g4udpq5a4r02"
	SK        = "edc5wabhdfvsnige"
	Region    = macros.PAAS_REGION_CN_SOUTHWEST_1
	CompanyID = "2000000000000008"
	License   = "728993384242373"
	DID       = "13001164400000dd"
)

func TestZZYClient_SubscribeDevice(t *testing.T) {

	cli := CreateZZYClient(AK, SK, Region)
	//cli.Device.GetDeviceConfig()
	//cli.Subscribe

	fmt.Println(cli.Subscribe.SubscribeProduct(CompanyID, macros.PAAS_SUB_TOPIC_DEVICESTATUS))
	fmt.Println(cli.Subscribe.SubscribeProduct(CompanyID, macros.PAAS_SUB_TOPIC_DEVICEEVENT))
	fmt.Println(cli.Subscribe.SubscribeProduct(CompanyID, macros.PAAS_SUB_TOPIC_DEVICECLOUDPICTURE))
	fmt.Println(cli.Subscribe.SubscribeProduct(CompanyID, macros.PAAS_SUB_TOPIC_DEVICECLOUDVIDEO))
	fmt.Println(cli.Subscribe.SubscribeProduct(CompanyID, macros.PAAS_SUB_TOPIC_DEVICECONFIG))
	fmt.Println(cli.Subscribe.SubscribeProduct(CompanyID, macros.PAAS_SUB_TOPIC_DEVICEUPGRADE))
	fmt.Println(cli.Subscribe.SubscribeProduct(CompanyID, macros.PAAS_SUB_TOPIC_DEVICEREGIST))

	//fmt.Println(cli.Subscribe.SubscribeDevice(License, macros.PAAS_SUB_TOPIC_DEVICESTATUS))
	//fmt.Println(cli.Subscribe.SubscribeDevice(License, macros.PAAS_SUB_TOPIC_DEVICEEVENT))
	//fmt.Println(cli.Subscribe.SubscribeDevice(License, macros.PAAS_SUB_TOPIC_DEVICECLOUDPICTURE))
	//fmt.Println(cli.Subscribe.SubscribeDevice(License, macros.PAAS_SUB_TOPIC_DEVICECLOUDVIDEO))
	//fmt.Println(cli.Subscribe.SubscribeDevice(License, macros.PAAS_SUB_TOPIC_DEVICECONFIG))
	//fmt.Println(cli.Subscribe.SubscribeDevice(License, macros.PAAS_SUB_TOPIC_DEVICEUPGRADE))
	//fmt.Println(cli.Subscribe.SubscribeDevice(License, macros.PAAS_SUB_TOPIC_DEVICEREGIST))

	//fmt.Println(cli.Device.GetDeviceStatus(License, DID))
	//fmt.Println(cli.Device.GetDeviceConfig(License, DID))

	//fmt.Println(cli.UnSubscribeProduct("2000000000000008", PAAS_SUB_TOPIC_DEVICESTATUS))

}

func TestZZYClient_Event(t *testing.T) {

	cli := CreateZZYClient(AK, SK, Region)

	st := time.Now().Format("2006-01-02 00:00:00")
	fmt.Println(cli.Event.GetEventList(License, DID, st, "", 10, 1, "2022080114531203445500020000000a"))

	date := time.Now().Add(-time.Hour * 24 * 30).Format("2006-01-02")
	fmt.Println(cli.Event.GetEventCalendar(License, DID, date, ""))

	fmt.Println(cli.Event.UpdateEventInfo(License, DID, []busi.EventCustomMsg{
		{
			EID:       "20220801150218346194000300000013",
			CustomMsg: `{"a":"1","b":"2"}`,
		},
	}))

	fmt.Println(cli.Event.DeleteEventInfo(License, DID, []string{"20220801150218346194000300000013"}))
}

func TestZZYClient_Video(t *testing.T) {
	cli := CreateZZYClient(AK, SK, Region)

	st := time.Now().Format("2006-01-02 00:00:00")
	fmt.Println(cli.Video.GetVideoList(License, DID, st, "", 10))

	date := time.Now().Add(-time.Hour * 24 * 30).Format("2006-01-02")
	fmt.Println(cli.Video.GetVideoCalendar(License, DID, date, ""))

	//fmt.Println(cli.Event.UpdateEventInfo(License, DID, []busi.EventCustomMsg{
	//	{
	//		EID:       "20220801150218346194000300000013",
	//		CustomMsg: `{"a":"1","b":"2"}`,
	//	},
	//}))

	fmt.Println(cli.Video.GetVideoDetail(License, DID, "20220801145119100003400000dd0032"))
}

func TestZZYClient_Picture(t *testing.T) {
	cli := CreateZZYClient(AK, SK, Region)

	//st := time.Now().Format("2006-01-02 00:00:00")
	//fmt.Println(cli.Picture.GetPictureList(License, DID, st, "", 10))

	//date := time.Now().Add(-time.Hour * 24 * 30).Format("2006-01-02")
	//fmt.Println(cli.Picture.GetPictureCalendar(License, DID, date, ""))

	//fmt.Println(cli.Event.UpdateEventInfo(License, DID, []busi.EventCustomMsg{
	//	{
	//		EID:       "20220801150218346194000300000013",
	//		CustomMsg: `{"a":"1","b":"2"}`,
	//	},
	//}))

	fmt.Println(cli.Picture.GetPictureDetail(License, DID, "20220807143556200003000000dc0286"))
	//fmt.Println(cli.Picture.GetPictureDetailByTime(License, DID, "2022-08-01 14:55:33"))
}

func TestZZYClient_Preset(t *testing.T) {
	cli := CreateZZYClient(AK, SK, Region)

	//fmt.Println(cli.Preset.PrefetchURL(License, DID, 2))
	//fmt.Println(cli.Preset.Report(License, DID, "20220801225552100003400000dd0002", "preset/0000213ed0cdb8bc/1591190546710147/13001164400000dd/1659365752_1", "hmcloud", 11111, nil))
	fmt.Println(cli.Preset.GetPresetFileDetail(License, DID, "20220801225552100003400000dd0002"))
	fmt.Println(cli.Preset.DeletePresetFile(License, DID, "20220801225552100003400000dd0002"))
}

func TestZZYClient_Bind(t *testing.T) {
	cli := CreateZZYClient(AK, SK, Region)

	fmt.Println(cli.Bind.AddBindTag("728993384242373", "13001164000000dc", "22000102c0ca9f2f"))
	//fmt.Println(cli.Bind.AddBindTag(License, DID, "22000102c0ca9f2f"))
	//fmt.Println(cli.Bind.DeleteBindTag(License, DID, "22000102c0ca9f2f"))
}

func TestZZYClient_Trans(t *testing.T) {
	cli := CreateZZYClient(AK, SK, Region)

	//fmt.Println(cli.Trans.DeviceCmd("13001164000000dc", 3412, nil))
	//fmt.Println(cli.Trans.DeviceCmd(DID, 3412, nil))
	fmt.Println(cli.Trans.DeviceCmd(DID, 3472, nil))
}

func TestZZYClient_Media(t *testing.T) {
	cli := CreateZZYClient(AK, SK, Region)

	fmt.Println(cli.Media.GetMedia("728993384242373", "13001164000000dc", "", "22000102c0ca9f2f", 0, 0))
}
