package busi

import "paas-golang/macros"

type Bind struct {
	writer Writer
}

func InitBind(writer Writer) *Bind {
	return &Bind{writer: writer}
}

func (bind *Bind) AddBindTag(license string, did string, bindTag string) error {
	m := map[string]interface{}{
		"License": license,
		"DID":     did,
		"BindTag": bindTag,
	}
	return bind.writer.RemoteRequestZZYServer(macros.PASS_PATH_BIND, m, macros.OPENAPI_ACTION_BIND_ADDBINDTAG, nil)
}

func (bind *Bind) DeleteBindTag(license string, did string, bindTag string) error {
	m := map[string]interface{}{
		"License": license,
		"DID":     did,
		"BindTag": bindTag,
	}
	return bind.writer.RemoteRequestZZYServer(macros.PASS_PATH_BIND, m, macros.OPENAPI_ACTION_BIND_DELETEBINDTAG, nil)
}
