package busi

import (
	"paas-golang/macros"
)

type Device struct {
	writer Writer
}

func InitDevice(writer Writer) *Device {
	return &Device{writer: writer}
}

func (device *Device) GetDeviceStatus(license string, did string) error {
	m := map[string]interface{}{
		"License": license,
		"DID":     did,
	}
	return device.writer.RemoteRequestZZYServer(macros.PASS_PATH_DEVICE, m, macros.OPENAPI_ACTION_DEVICE_QUERYDEVICESTATUS, nil)
}

func (device *Device) GetDeviceConfig(license string, did string) error {
	m := map[string]interface{}{
		"License": license,
		"DID":     did,
	}
	return device.writer.RemoteRequestZZYServer(macros.PASS_PATH_DEVICE, m, macros.OPENAPI_ACTION_DEVICE_QUERYDEVICECONFIG, nil)
}
