package busi

import (
	"paas-golang/macros"
	"strconv"
)

type Media struct {
	writer Writer
}

func InitMedia(writer Writer) *Media {
	return &Media{writer: writer}
}

func (media *Media) GetMedia(license string, did string, usertoken string, bindTag string, mediatype uint16, ostype macros.OSTYPE) error {
	m := map[string]interface{}{
		"BindTag":   bindTag,
		"DID":       did,
		"License":   license,
		"UserToken": usertoken,
		"MediaType": strconv.Itoa(int(mediatype)),
		"OSType":    strconv.Itoa(int(ostype)),
	}

	return media.writer.RemoteRequestZZYServer(macros.PASS_PATH_MEDIA, m, macros.OPENAPI_ACTION_MEDIA_GETMEDIA, nil)
}

func (media *Media) GetOldMedia() error {
	m := map[string]interface{}{}

	return media.writer.RemoteRequestZZYServer(macros.PASS_PATH_MEDIA, m, macros.OPENAPI_ACTION_MEDIA_GETOLDMEDIA, nil)
}
