package busi

import (
	"paas-golang/macros"
	"strconv"
)

type Picture struct {
	writer Writer
}

func InitPicture(writer Writer) *Picture {
	return &Picture{writer: writer}
}

func (pic *Picture) GetPictureCalendar(license string, did string, date, bindTag string) error {

	m := map[string]interface{}{
		"License": license,
		"DID":     did,
		"Date":    date,
		"BindTag": bindTag,
	}
	return pic.writer.RemoteRequestZZYServer(macros.PASS_PATH_PICTURE, m, macros.OPENAPI_ACTION_PICTURE_QUERYCALENDAR, nil)
}

func (pic *Picture) GetPictureList(license string, did string, date, bindTag string, pageSize uint16) error {

	m := map[string]interface{}{
		"License":  license,
		"DID":      did,
		"Date":     date,
		"PageSize": strconv.Itoa(int(pageSize)),
		"BindTag":  bindTag,
	}
	return pic.writer.RemoteRequestZZYServer(macros.PASS_PATH_PICTURE, m, macros.OPENAPI_ACTION_PICTURE_QUERYLIST, nil)
}

func (pic *Picture) GetPictureDetail(license string, did string, fileid string) error {

	m := map[string]interface{}{
		"License": license,
		"DID":     did,
		"FileID":  fileid,
	}
	return pic.writer.RemoteRequestZZYServer(macros.PASS_PATH_PICTURE, m, macros.OPENAPI_ACTION_PICTURE_QUERYDETAIL, nil)
}

func (pic *Picture) GetPictureDetailByTime(license string, did string, t string) error {

	m := map[string]interface{}{
		"License": license,
		"DID":     did,
		"Time":    t,
	}
	return pic.writer.RemoteRequestZZYServer(macros.PASS_PATH_PICTURE, m, macros.OPENAPI_ACTION_PICTURE_QUERYDETAILBYTIME, nil)
}
