package busi

import (
	"paas-golang/macros"
	"strconv"
)

type Subscribe struct {
	writer Writer
}

func InitSubscribe(writer Writer) *Subscribe {
	return &Subscribe{writer: writer}
}

func (sub *Subscribe) SubscribeProduct(productid string, topic macros.PAAS_SUB_TOPIC) error {
	m := map[string]interface{}{
		"ProductID": productid,
		"Status":    strconv.Itoa(int(macros.SUBSCRIBE_STATUS_SUBSCRIBE)),
		"Topic":     string(topic),
	}
	return sub.writer.RemoteRequestZZYServer(macros.PASS_PATH_SUBSCRIBE, m, macros.OPENAPI_ACTION_SUBSCRIBE_PRODUCT, nil)
}

func (sub *Subscribe) UnSubscribeProduct(productid string, topic macros.PAAS_SUB_TOPIC) error {
	m := map[string]interface{}{
		"ProductID": productid,
		"Status":    strconv.Itoa(int(macros.SUBSCRIBE_STATUS_UNSUBSCRIBE)),
		"Topic":     string(topic),
	}
	return sub.writer.RemoteRequestZZYServer(macros.PASS_PATH_SUBSCRIBE, m, macros.OPENAPI_ACTION_SUBSCRIBE_PRODUCT, nil)
}

func (sub *Subscribe) SubscribeDevice(license string, topic macros.PAAS_SUB_TOPIC) error {
	m := map[string]interface{}{
		"License": license,
		"Status":  strconv.Itoa(int(macros.SUBSCRIBE_STATUS_SUBSCRIBE)),
		"Topic":   string(topic),
	}
	return sub.writer.RemoteRequestZZYServer(macros.PASS_PATH_SUBSCRIBE, m, macros.OPENAPI_ACTION_SUBSCRIBE_DEVICE, nil)
}

func (sub *Subscribe) UnSubscribeDevice(license string, topic macros.PAAS_SUB_TOPIC) error {
	m := map[string]interface{}{
		"License": license,
		"Status":  strconv.Itoa(int(macros.SUBSCRIBE_STATUS_UNSUBSCRIBE)),
		"Topic":   string(topic),
	}
	return sub.writer.RemoteRequestZZYServer(macros.PASS_PATH_SUBSCRIBE, m, macros.OPENAPI_ACTION_SUBSCRIBE_DEVICE, nil)
}
