package busi

import (
	"paas-golang/macros"
	"strconv"
)

type Trans struct {
	writer Writer
}

func InitTrans(writer Writer) *Trans {
	return &Trans{writer: writer}
}

func (trans *Trans) DeviceCmd(did string, method uint32, data map[string]interface{}) error {
	m := map[string]interface{}{
		"DID":    did,
		"Method": strconv.Itoa(int(method)),
	}

	if len(data) > 0 {
		m["Data"] = data
	}

	return trans.writer.RemoteRequestZZYServer(macros.PASS_PATH_TRANS, m, macros.OPENAPI_ACTION_TRANS_DEVICECMD, nil)
}
