package busi

import (
	"paas-golang/macros"
	"strconv"
)

type Video struct {
	writer Writer
}

func InitVideo(writer Writer) *Video {
	return &Video{writer: writer}
}

func (video *Video) GetVideoCalendar(license string, did string, date, bindTag string) error {

	m := map[string]interface{}{
		"License": license,
		"DID":     did,
		"Date":    date,
		"BindTag": bindTag,
	}
	return video.writer.RemoteRequestZZYServer(macros.PASS_PATH_VIDEO, m, macros.OPENAPI_ACTION_VIDEO_QUERYCALENDAR, nil)
}

func (video *Video) GetVideoList(license string, did string, date, bindTag string, pageSize uint16) error {

	m := map[string]interface{}{
		"License":  license,
		"DID":      did,
		"Date":     date,
		"PageSize": strconv.Itoa(int(pageSize)),
		"BindTag":  bindTag,
	}
	return video.writer.RemoteRequestZZYServer(macros.PASS_PATH_VIDEO, m, macros.OPENAPI_ACTION_VIDEO_QUERYLIST, nil)
}

func (video *Video) GetVideoDetail(license string, did string, fileid string) error {

	m := map[string]interface{}{
		"License": license,
		"DID":     did,
		"FileID":  fileid,
	}
	return video.writer.RemoteRequestZZYServer(macros.PASS_PATH_VIDEO, m, macros.OPENAPI_ACTION_VIDEO_QUERYDETAIL, nil)
}
