package sign

import (
	"bytes"
	"crypto/hmac"
	"crypto/sha256"
	"encoding/hex"
)

var keylen = len("AccessKey") + len("Action") + len("Data") + len("Nonce") + len("Timestamp") + len("Ver")

func PaaSOpenInterfaceSignatureV1(ak string, sk string, nonce string, data string, ts string, action string, ver string) string {
	//AccessKey123456789012345ActionProductDatac6df69afc225592ac6135f65bd3f3541c89f61ad00cdbf735810bd6f2c84fd2cNonce123456789012345Timestamp1585419658Verv1

	bs := bytes.Buffer{}
	bs.Grow(keylen + len(ak) + len(sk) + len(nonce) + len(data) + len(ts) + len(action) + len(ver))
	bs.WriteString("AccessKey")
	bs.WriteString(ak)
	bs.WriteString("Action")
	bs.WriteString(action)
	bs.WriteString("Data")
	bs.WriteString(data)
	bs.WriteString("Nonce")
	bs.WriteString(nonce)
	bs.WriteString("Timestamp")
	bs.WriteString(ts)
	bs.WriteString("Ver")
	bs.WriteString(ver)

	bs.Bytes()

	return HMAC_SHA256_HEX([]byte(sk), bs.Bytes())
}

func HMAC_SHA256_HEX(key []byte, p []byte) string {
	hmacSha256 := hmac.New(sha256.New, key)
	hmacSha256.Write(p)
	signature := hex.EncodeToString(hmacSha256.Sum(nil))
	return signature
}
